#!/bin/sh
#
# Hans-Peter Seiler / 08.12.2005
#
# /var/install/config.d/dyndns-update.sh

. /var/install/include/eislib
prog=dyndns

# Update conf version 1.0.14
if grep "1.0.14" /etc/config.d/$prog-sich >/dev/null 2>&1 ; then
    cp -a /etc/config.d/$prog-sich /etc/config.d/$prog

    # change version data
    sed "s#[Dd]yndns 1.[0-9].[0-9]*#Dyndns 1.1.0#" "/etc/config.d/$prog" >/tmp/$prog-$$
    mv /tmp/$prog-$$ /etc/config.d/$prog

    sed "s#Update:  [0-9]*.[0-9]*.[0-9]*#Update:  02.01.2006#" "/etc/config.d/$prog" >/tmp/$prog-$$
    mv /tmp/$prog-$$ /etc/config.d/$prog

    # change provider data
    sed "s#DYNDNS_DEALER#DYNDNS_PROVIDER#" "/etc/config.d/$prog" >/tmp/$prog-$$
    mv /tmp/$prog-$$ /etc/config.d/$prog
    sed "s#\# dyndns noip hn#\# dyndns noip hn regfish#" "/etc/config.d/$prog" >/tmp/$prog-$$
    mv /tmp/$prog-$$ /etc/config.d/$prog

    # change dyndns data
    idxn=`grep "DYNDNS_N_HOST" /etc/config.d/dyndns | cut -d "'" -f 2`
    idx=0
    while [ "$idx" -le "$idxn" ] ; do
        if [ "$idx" -eq "0" ] ; then
            nr=1
        else
            nr=$idx
        fi
        sed "s#DYNDNS_"$nr"_HOST#DYNDNS_HOST_"$nr"#" "/etc/config.d/$prog" >/tmp/$prog-$$
        mv /tmp/$prog-$$ /etc/config.d/$prog
        idx=`expr $idx + 1`
    done

    idx=0
    while [ "$idx" -le "$idxn" ] ; do
        if [ "$idx" -eq "0" ] ; then
            nr=1
        else
            nr=$idx
        fi
        sed "s#DYNDNS_"$nr"_MXHOST#DYNDNS_HOST_"$nr"_MXHOST#" "/etc/config.d/$prog" >/tmp/$prog-$$
        mv /tmp/$prog-$$ /etc/config.d/$prog
        idx=`expr $idx + 1`
    done

    idx=0
    while [ "$idx" -le "$idxn" ] ; do
        if [ "$idx" -eq "0" ] ; then
            nr=1
        else
            nr=$idx
        fi
        sed "s#DYNDNS_"$nr"_WILDCARD#DYNDNS_HOST_"$nr"_WC#" "/etc/config.d/$prog" >/tmp/$prog-$$
        mv /tmp/$prog-$$ /etc/config.d/$prog
        idx=`expr $idx + 1`
    done

    idx=0
    while [ "$idx" -le "$idxn" ] ; do
        if [ "$idx" -eq "0" ] ; then
            nr=1
        else
            nr=$idx
        fi
        sed "s#DYNDNS_"$nr"_BACKMX#DYNDNS_HOST_"$nr"_MX#" "/etc/config.d/$prog" >/tmp/$prog-$$
        mv /tmp/$prog-$$ /etc/config.d/$prog
        idx=`expr $idx + 1`
    done
    sed "s#DYNDNS_N_HOST#DYNDNS_HOST_N#" "/etc/config.d/$prog" >/tmp/$prog-$$
    mv /tmp/$prog-$$ /etc/config.d/$prog

    # change noip data
    idxn=`grep "DYNDNS_NOIP_N_HOST" /etc/config.d/dyndns | cut -d "'" -f 2`
    idx=0
    while [ "$idx" -le "$idxn" ] ; do
        if [ "$idx" -eq "0" ] ; then
            nr=1
        else
            nr=$idx
        fi
        sed "s#DYNDNS_NOIP_"$nr"_HOST#DYNDNS_NOIP_HOST_"$nr"#" "/etc/config.d/$prog" >/tmp/$prog-$$
        mv /tmp/$prog-$$ /etc/config.d/$prog
        idx=`expr $idx + 1`
    done
    sed "s#DYNDNS_NOIP_N_HOST#DYNDNS_NOIP_HOST_N#" "/etc/config.d/$prog" >/tmp/$prog-$$
    mv /tmp/$prog-$$ /etc/config.d/$prog

    # backup Hn data
    {
    grep "# Hn" /etc/config.d/$prog
    echo
    grep "DYNDNS_HN" /etc/config.d/$prog
    } >/tmp/hndata

    # backup Mail data
    grep "DYNDNS_INFO_MAIL" /etc/config.d/$prog >/tmp/maildata

    # rm data between ... and ...
    sed "/\# Hn/,/DYNDNS_INFO_MAIL_ADDR/d" "/etc/config.d/$prog" >/tmp/$prog-$$
    mv /tmp/$prog-$$ /etc/config.d/$prog

    # restore Hn data
    cat "/tmp/hndata" >>/etc/config.d/$prog && rm /tmp/hndata

    # create new parameters
    {
    echo
    echo "DYNDNS_HN_HOST_N='0'"
    echo "DYNDNS_HN_HOST_1=''                   # hostname of your server"
    echo
    echo "#----------------------------------------------------------------------------"
    echo
    echo "# Regfish"
    echo
    echo "DYNDNS_REGFISH_USER=''                # username"
    echo "DYNDNS_REGFISH_PASS=''                # password"
    echo
    echo "DYNDNS_REGFISH_HOST_N='0'"
    echo "DYNDNS_REGFISH_HOST_1=''              # hostname of your server"
    echo "DYNDNS_REGFISH_HOST_1_MX='no'         # Host is Backmx? yes or no"
    echo
    echo "#----------------------------------------------------------------------------"
    echo
    } >>/etc/config.d/$prog

    # restore Mail data
    cat "/tmp/maildata" >>/etc/config.d/$prog && rm /tmp/maildata
elif grep "1.1.0" /etc/config.d/$prog-sich >/dev/null 2>&1 ; then
    cp -a /etc/config.d/$prog-sich /etc/config.d/$prog
    sed "s#Update:  [0-9]*.[0-9]*.[0-9]*#Update:  02.01.2006#" "/etc/config.d/$prog" >/tmp/$prog-$$
    mv /tmp/$prog-$$ /etc/config.d/$prog
else
    cp -a /etc/default.d/$prog /etc/config.d/$prog
fi
